/* keypad.h (based on Dovoto's Version) */

#ifndef KEYPAD_H
#define KEYPAD_H

/* Enumerations */
#define KEY_A 		1
#define KEY_B 		2
#define KEY_SELECT	4
#define KEY_START 	8
#define KEY_RIGHT 	16
#define KEY_LEFT 	32
#define KEY_UP 		64
#define KEY_DOWN 	128
#define KEY_R		256
#define KEY_L 		512

/* Globals */
volatile u32* KEYS = (volatile u32*)0x04000130;

void WaitKey(int whatKey)
{
	while(1)
	{
		if(!(*KEYS & whatKey))
		{
			break;
		}
	}
}

int GetInput(void)
{
	int i=0, key=0;

	if(!(*KEYS & KEY_UP))
	{
		key = 1;
	}
	if(!(*KEYS & KEY_DOWN))
	{
		key = 2;
	}
	if(!(*KEYS & KEY_LEFT))
	{
		key = 3;
	}
	if(!(*KEYS & KEY_RIGHT))
	{
		key = 4;
	}
	if(!(*KEYS & KEY_START))
	{
		key = 5;
	}
	if(!(*KEYS & KEY_A))
	{
		key = 6;
	}
	if(!(*KEYS & KEY_B))
	{
		key = 7;
	}
	if(!(*KEYS & KEY_SELECT))
	{
		key = 8;
	}
	if(!(*KEYS & KEY_L))
	{
		key = 9;
	}
	if(!(*KEYS & KEY_R))
	{
		key = 10;
	}

	return key;
}

#endif
