/* text.h
   quick and dirty text output for the Gameboy Advance
   by Benjamin Molitor <b.molitor@gmx.net> in 2001
   I might tidy this up one day, but then again, I might not. 
   Probably. If you really want to use this, do so, but keep this
   disclaimer intact and drop me a line so I can laugh at you :)
*/

/* rgb macro */
#define RGB(r,g,b) ((r)+((g)<<5)+((b)<<10)) 

#include "font.h"

void plotpixel (int x,int y, unsigned short int c) 
{ 
	VideoBuffer[(y) *240 + (x)] = (c); 
}

void plotletter (int xoffset, int yoffset, int letter, int foreground, int background)
{
	int x, y, absx, absy;
	unsigned short int rgb;

	letter=letter-32;	/* the font data in font.h starts at the beginning of the printable characters */

	for(x = 0; x<8; x++)
	{
		for(y = 0; y<8; y++)
		{
			absx = x + xoffset;
			absy = y + yoffset;

			if (fontdata[(letter*64)+y*8+x] == 0)
			{
				plotpixel(absx, absy, background);
			} else {
				plotpixel(absx, absy, foreground);
			}

		}
	}
}

void gprint(int x, int y, char *text, int textcolor, int bgcolor)
{
	int loop;

	for (loop=0; loop < strlen(text); loop++)
	{
		if (text[loop]=='\n')
		{
			y++;
			loop++;
			x=0-loop;
		}
		if ((x+loop) >= 30)
		{
			y++;
			x=0-loop;
		}

		plotletter((x+loop)*8, y*8, text[loop], textcolor, bgcolor);
	}
}

char* wrap(char* text, int length)
{
        int i=0, lastspace=0, lastwrap=0;
        for (i = 0; i < strlen(text); i++)
        {
                if (text[i]==' ') lastspace = i;
		if(i-lastwrap >= length)
		{
			text[lastspace]='\n';
			lastwrap=lastspace;
		}
	}
	return(text);
}

void clrscr(int color)	
{
/* clear screen with the color given */

	for(int x = 0; x<38400; x++)
	{
		VideoBuffer[x] = color;
	}
}

int doscolor(int nummer)
{
	int farbe;
	switch (nummer)
	{
		case 0:
			farbe = RGB(0,0,0);
			break;
		case 1:
			farbe = RGB(0,0,22);
			break;
		case 2:
			farbe = RGB(0,22,0);
			break;
		case 3:
			farbe = RGB(0,22,22);
			break;
		case 4:
			farbe = RGB(22,0,22);
			break;
		case 5:
			farbe = RGB(22,0,0);
			break;
		case 6:
			farbe = RGB(22,22,0);
			break;
		case 7:
			farbe = RGB(28,28,28);
			break;
		case 8:
			farbe = RGB(20,20,20);
			break;
		case 9:
			farbe = RGB(0,0,31);
			break;
		case 10:
			farbe = RGB(0,31,0);
			break;
		case 11:
			farbe = RGB(0,31,31);
			break;
		case 12:
			farbe = RGB(31,0,31);
			break;
		case 13:
			farbe = RGB(31,0,0);
			break;
		case 14:
			farbe = RGB(31,31,0);
			break;
		case 15:
			farbe = RGB(31,31,31);
			break;
		default:
			farbe = RGB(0,0,0);
			return farbe;
	}
	return farbe;
}
